/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the DataSourceDescriptorMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataSourceDescriptorMutable{}

// DataSourceDescriptorMutable struct for DataSourceDescriptorMutable
type DataSourceDescriptorMutable struct {
	GroupId *string `json:"group_id,omitempty"`
	SourceType DataSource `json:"source_type"`
	SubType string `json:"sub_type"`
	Description string `json:"description"`
	Properties []DataSourceDescriptorProperty `json:"properties"`
}

// NewDataSourceDescriptorMutable instantiates a new DataSourceDescriptorMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataSourceDescriptorMutable(sourceType DataSource, subType string, description string, properties []DataSourceDescriptorProperty) *DataSourceDescriptorMutable {
	this := DataSourceDescriptorMutable{}
	this.SourceType = sourceType
	this.SubType = subType
	this.Description = description
	this.Properties = properties
	return &this
}

// NewDataSourceDescriptorMutableWithDefaults instantiates a new DataSourceDescriptorMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataSourceDescriptorMutableWithDefaults() *DataSourceDescriptorMutable {
	this := DataSourceDescriptorMutable{}
	return &this
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *DataSourceDescriptorMutable) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorMutable) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *DataSourceDescriptorMutable) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *DataSourceDescriptorMutable) SetGroupId(v string) {
	o.GroupId = &v
}

// GetSourceType returns the SourceType field value
func (o *DataSourceDescriptorMutable) GetSourceType() DataSource {
	if o == nil {
		var ret DataSource
		return ret
	}

	return o.SourceType
}

// GetSourceTypeOk returns a tuple with the SourceType field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorMutable) GetSourceTypeOk() (*DataSource, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SourceType, true
}

// SetSourceType sets field value
func (o *DataSourceDescriptorMutable) SetSourceType(v DataSource) {
	o.SourceType = v
}

// GetSubType returns the SubType field value
func (o *DataSourceDescriptorMutable) GetSubType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SubType
}

// GetSubTypeOk returns a tuple with the SubType field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorMutable) GetSubTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SubType, true
}

// SetSubType sets field value
func (o *DataSourceDescriptorMutable) SetSubType(v string) {
	o.SubType = v
}

// GetDescription returns the Description field value
func (o *DataSourceDescriptorMutable) GetDescription() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Description
}

// GetDescriptionOk returns a tuple with the Description field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorMutable) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Description, true
}

// SetDescription sets field value
func (o *DataSourceDescriptorMutable) SetDescription(v string) {
	o.Description = v
}

// GetProperties returns the Properties field value
func (o *DataSourceDescriptorMutable) GetProperties() []DataSourceDescriptorProperty {
	if o == nil {
		var ret []DataSourceDescriptorProperty
		return ret
	}

	return o.Properties
}

// GetPropertiesOk returns a tuple with the Properties field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorMutable) GetPropertiesOk() ([]DataSourceDescriptorProperty, bool) {
	if o == nil {
		return nil, false
	}
	return o.Properties, true
}

// SetProperties sets field value
func (o *DataSourceDescriptorMutable) SetProperties(v []DataSourceDescriptorProperty) {
	o.Properties = v
}

func (o DataSourceDescriptorMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataSourceDescriptorMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.GroupId) {
		toSerialize["group_id"] = o.GroupId
	}
	toSerialize["source_type"] = o.SourceType
	toSerialize["sub_type"] = o.SubType
	toSerialize["description"] = o.Description
	toSerialize["properties"] = o.Properties
	return toSerialize, nil
}

type NullableDataSourceDescriptorMutable struct {
	value *DataSourceDescriptorMutable
	isSet bool
}

func (v NullableDataSourceDescriptorMutable) Get() *DataSourceDescriptorMutable {
	return v.value
}

func (v *NullableDataSourceDescriptorMutable) Set(val *DataSourceDescriptorMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSourceDescriptorMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSourceDescriptorMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSourceDescriptorMutable(val *DataSourceDescriptorMutable) *NullableDataSourceDescriptorMutable {
	return &NullableDataSourceDescriptorMutable{value: val, isSet: true}
}

func (v NullableDataSourceDescriptorMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSourceDescriptorMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


